diff -pruN 4.0-1/debian/changelog 4.0-1ubuntu3/debian/changelog
--- 4.0-1/debian/changelog	2020-08-19 22:49:24.000000000 +0000
+++ 4.0-1ubuntu3/debian/changelog	2020-10-26 15:04:41.000000000 +0000
@@ -1,3 +1,40 @@
+sosreport (4.0-1ubuntu3) hirsute; urgency=medium
+
+  [Edward Hope-Morley]
+  * d/p/0008-networking-include-ip-neigh-and-rule-info.patch:
+    - Include ns ip neigh and ip rule info. (LP: #1901555)
+
+ -- Eric Desrochers <eric.desrochers@canonical.com>  Mon, 26 Oct 2020 11:04:41 -0400
+
+sosreport (4.0-1ubuntu2) groovy; urgency=medium
+
+  [Nicolas Bock]
+  * d/p/0007-rabbitmq-add-10sec-timeout-to-call-to-maybestuck.patch:
+    - Add 10 second timeout to call to `maybe_stuck()`.
+
+ -- Eric Desrochers <eric.desrochers@canonical.com>  Mon, 21 Sep 2020 10:47:11 -0400
+
+sosreport (4.0-1ubuntu1) groovy; urgency=medium
+
+  [Eric Desrochers]
+  * d/p/0003-sosclean-fix-handling-of-filepath-with-archive-name.patch:
+    - Fixes the splitting of filepaths within the archive,
+      when the archive name is included in the filename
+      inside the archive. (LP: #1896222)
+
+  * d/p/0004-sosclean-fix-tarball-skipping-regex.patch: 
+    - Fix tarball skipping regex
+
+  [Dan Hill]
+  * d/p/0005-ceph-collect-balancer-and-pg-autoscale-status.patch:
+    - Collect balancer and pg-autoscale status (LP: #1893109)
+
+  [Nicolas Bock]
+  * d/p/0006-rabbitmq-add-info-on-maybe-stuck-processes.patch:
+    - Add information on maybe_stuck() processes for RMQ. (LP: #1890846)
+
+ -- Eric Desrochers <eric.desrochers@canonical.com>  Fri, 18 Sep 2020 09:23:04 -0400
+
 sosreport (4.0-1) unstable; urgency=medium
 
   * New 4.0 upstream release.
diff -pruN 4.0-1/debian/patches/0003-sosclean-fix-handling-of-filepath-with-archive-name.patch 4.0-1ubuntu3/debian/patches/0003-sosclean-fix-handling-of-filepath-with-archive-name.patch
--- 4.0-1/debian/patches/0003-sosclean-fix-handling-of-filepath-with-archive-name.patch	1970-01-01 00:00:00.000000000 +0000
+++ 4.0-1ubuntu3/debian/patches/0003-sosclean-fix-handling-of-filepath-with-archive-name.patch	2020-09-18 13:23:04.000000000 +0000
@@ -0,0 +1,20 @@
+Description: [cleaner] Fix handling of filepath when archive name is in the filepath
+ Fixes the splitting of filepaths within the archive, when the archive
+ name is included in the filename inside the archive.
+
+ Related: #2236
+Author: Jake Hunsaker <jhunsake@redhat.com>
+Origin: upstream, https://github.com/sosreport/sos/pull/2238/commits/ca7cb3440618492e9cf5c7fee77623066bd4b0b7 
+Bug: https://github.com/sosreport/sos/issues/2236
+Bug-Ubuntu: https://launchpad.net/bugs/1896222
+--- a/sos/cleaner/__init__.py
++++ b/sos/cleaner/__init__.py
+@@ -483,7 +483,7 @@
+ 
+             file_list = archive.get_file_list()
+             for fname in file_list:
+-                short_name = fname.split(archive.archive_name)[1].lstrip('/')
++                short_name = fname.split(archive.archive_name + '/')[1]
+                 if archive.should_skip_file(short_name):
+                     continue
+                 try:
diff -pruN 4.0-1/debian/patches/0004-sosclean-fix-tarball-skipping-regex.patch 4.0-1ubuntu3/debian/patches/0004-sosclean-fix-tarball-skipping-regex.patch
--- 4.0-1/debian/patches/0004-sosclean-fix-tarball-skipping-regex.patch	1970-01-01 00:00:00.000000000 +0000
+++ 4.0-1ubuntu3/debian/patches/0004-sosclean-fix-tarball-skipping-regex.patch	2020-09-18 13:23:04.000000000 +0000
@@ -0,0 +1,29 @@
+Description: [obfuscation_archive] Fix tarball skipping regex
+ The regex used to skip tarballs was slightly too vague, in that we were
+ checking for any characters following 'tar', instead of any characters
+ following 'tar.'. This in turn lead to the potential for skipping files
+ that included the original sosreport archive's name.
+
+ Make the regex more exact to no longer make these accidental matches,
+ and only match on true tarballs.
+
+ Closes: sosreport#2236
+ Resolves: sosreport#2238
+
+Author: Jake Hunsaker <jhunsake@redhat.com>
+Origin: upstream, https://github.com/sosreport/sos/pull/2238/commits/fec409c9198b02fa13527f6bef6a1d63bd402dbf
+Bug: https://github.com/sosreport/sos/issues/2236
+Bug-Ubuntu: https://bugs.launchpad.net/bugs/1896222
+--- a/sos/cleaner/obfuscation_archive.py
++++ b/sos/cleaner/obfuscation_archive.py
+@@ -73,7 +73,9 @@
+             'sys/kernel/debug',
+             'sys/module',
+             'var/log/.*dnf.*',
+-            '.*.tar.*',  # TODO: support archive unpacking
++            '.*\.tar$',  # TODO: support archive unpacking
++            # Be explicit with these tar matches to avoid matching commands
++            '.*\.tar\.xz',
+             '.*.gz'
+         ]
+ 
diff -pruN 4.0-1/debian/patches/0005-ceph-collect-balancer-and-pg-autoscale-status.patch 4.0-1ubuntu3/debian/patches/0005-ceph-collect-balancer-and-pg-autoscale-status.patch
--- 4.0-1/debian/patches/0005-ceph-collect-balancer-and-pg-autoscale-status.patch	1970-01-01 00:00:00.000000000 +0000
+++ 4.0-1ubuntu3/debian/patches/0005-ceph-collect-balancer-and-pg-autoscale-status.patch	2020-09-18 13:23:04.000000000 +0000
@@ -0,0 +1,38 @@
+Description: [ceph] collect balancer and pg-autoscale status
+ Adding the following two commands to the ceph plug-in:
+ ceph osd pool autoscale-status
+ ceph balancer status
+
+ The autoscale-status command lists each pool, its relative utilization,
+ and any suggested changes to the PG count.
+
+ The balancer status command reports any recorded or active plans.
+
+ [0] https://docs.ceph.com/docs/master/rados/operations/placement-groups/
+ [1] https://docs.ceph.com/docs/mimic/mgr/balancer/
+
+ Closes: #2211
+ Resolves: #2212
+
+Author: Dan Hill daniel.hill@canonical.com
+Origin: upstream, https://github.com/sosreport/sos/commit/52f4661e2b594134b98e2967b02cc860d7963fef
+Bug: https://github.com/sosreport/sos/issues/2211
+Bug-Ubuntu: https://bugs.launchpad.net/bugs/1893109
+--- a/sos/report/plugins/ceph.py
++++ b/sos/report/plugins/ceph.py
+@@ -65,6 +65,7 @@
+             "ceph mon_status",
+             "ceph quorum_status",
+             "ceph mgr module ls",
++            "ceph balancer status",
+             "ceph mgr metadata",
+             "ceph osd metadata",
+             "ceph osd erasure-code-profile ls",
+@@ -95,6 +96,7 @@
+             "osd perf",
+             "osd blocked-by",
+             "osd pool ls detail",
++            "osd pool autoscale-status",
+             "osd numa-status",
+             "device ls",
+             "mon dump",
diff -pruN 4.0-1/debian/patches/0006-rabbitmq-add-info-on-maybe-stuck-processes.patch 4.0-1ubuntu3/debian/patches/0006-rabbitmq-add-info-on-maybe-stuck-processes.patch
--- 4.0-1/debian/patches/0006-rabbitmq-add-info-on-maybe-stuck-processes.patch	1970-01-01 00:00:00.000000000 +0000
+++ 4.0-1ubuntu3/debian/patches/0006-rabbitmq-add-info-on-maybe-stuck-processes.patch	2020-09-18 13:22:43.000000000 +0000
@@ -0,0 +1,36 @@
+Description: [rabbitmq] Add information on `maybe_stuck()` processes for RMQ
+ We have seen environments in which simple commands such as
+    rabbitmqctl list_queues
+ Get stuck and do not produce any output. We found it helpful to run
+    rabbitmqctl eval 'rabbitmq_diagnostics:maybe_stuck().'
+
+ To obtain a list of "stuck" Erlang processes for further analysis.
+ This change adds the output of the above command to the sosreport.
+
+ Depends-On: #2232
+ Closes: https://bugs.launchpad.net/ubuntu/+source/sosreport/+bug/1890846
+ Resolves: #2189
+
+Author: Nicolas Bock <nicolas.bock@canonical.com>
+Origin: upstream, https://github.com/sosreport/sos/commit/af5891786ff8c4e33c341fe9cca690fc77ac768f
+Bug: https://github.com/sosreport/sos/issues/2232
+Bug-Ubuntu: https://launchpad.net/bugs/1890846
+--- a/sos/report/plugins/rabbitmq.py
++++ b/sos/report/plugins/rabbitmq.py
+@@ -37,8 +37,16 @@
+                     self.fmt_container_cmd(container, 'rabbitmqctl report'),
+                     foreground=True
+                 )
++                self.add_cmd_output(
++                    self.fmt_container_cmd(
++                        container, "rabbitmqctl eval "
++                        "'rabbit_diagnostics:maybe_stuck().'"),
++                    foreground=True
++                )
+         else:
+             self.add_cmd_output("rabbitmqctl report")
++            self.add_cmd_output(
++                "rabbitmqctl eval 'rabbit_diagnostics:maybe_stuck().'")
+ 
+         self.add_copy_spec([
+             "/etc/rabbitmq/*",
diff -pruN 4.0-1/debian/patches/0007-rabbitmq-add-10sec-timeout-to-call-to-maybestuck.patch 4.0-1ubuntu3/debian/patches/0007-rabbitmq-add-10sec-timeout-to-call-to-maybestuck.patch
--- 4.0-1/debian/patches/0007-rabbitmq-add-10sec-timeout-to-call-to-maybestuck.patch	1970-01-01 00:00:00.000000000 +0000
+++ 4.0-1ubuntu3/debian/patches/0007-rabbitmq-add-10sec-timeout-to-call-to-maybestuck.patch	2020-09-21 14:47:01.000000000 +0000
@@ -0,0 +1,28 @@
+Description: [rabbitmq] Add 10 second timeout to call to `maybe_stuck()`.
+ The `maybe_stuck()` function might run for a long time if it is
+ tracking down a lot of potentially stuck processes. In order to
+ prevent long run times of `sos report` the `cmd` timeout should be set
+ explicitly. As a compromise between acceptable execution times and
+ information gathered from the plugin, this change introduces a timeout
+ of 10 seconds for the `maybe_stuck()` call.
+
+Author: Nicolas Bock <nicolas.bock@canonical.com>
+Origin: upstream, https://github.com/sosreport/sos/pull/2239/commits/5b5ebe2d2c9d579931c8d6a78101e16d6abfa527
+--- a/sos/report/plugins/rabbitmq.py
++++ b/sos/report/plugins/rabbitmq.py
+@@ -41,12 +41,13 @@
+                     self.fmt_container_cmd(
+                         container, "rabbitmqctl eval "
+                         "'rabbit_diagnostics:maybe_stuck().'"),
+-                    foreground=True
++                    foreground=True, timeout=10
+                 )
+         else:
+             self.add_cmd_output("rabbitmqctl report")
+             self.add_cmd_output(
+-                "rabbitmqctl eval 'rabbit_diagnostics:maybe_stuck().'")
++                "rabbitmqctl eval 'rabbit_diagnostics:maybe_stuck().'",
++                timeout=10)
+ 
+         self.add_copy_spec([
+             "/etc/rabbitmq/*",
diff -pruN 4.0-1/debian/patches/0008-networking-include-ip-neigh-and-rule-info.patch 4.0-1ubuntu3/debian/patches/0008-networking-include-ip-neigh-and-rule-info.patch
--- 4.0-1/debian/patches/0008-networking-include-ip-neigh-and-rule-info.patch	1970-01-01 00:00:00.000000000 +0000
+++ 4.0-1ubuntu3/debian/patches/0008-networking-include-ip-neigh-and-rule-info.patch	2020-10-26 15:04:33.000000000 +0000
@@ -0,0 +1,18 @@
+Description: [networking] Include ns ip neigh and ip rule info
+ Resolves: #2282
+ Closes: #2281
+Author: Edward Hope-Morley <edward.hope-morley@canonical.com>
+Origin: upstream, https://github.com/sosreport/sos/commit/0c5b4c15f880b1e96ac70ced1de2d7d4f989c19e
+Bug: https://github.com/sosreport/sos/issues/2281
+Bug-Ubuntu: https://launchpad.net/bugs/1901555
+--- a/sos/report/plugins/networking.py
++++ b/sos/report/plugins/networking.py
+@@ -268,6 +268,8 @@
+                 self.add_cmd_output([
+                     ns_cmd_prefix + "ip address show",
+                     ns_cmd_prefix + "ip route show table all",
++                    ns_cmd_prefix + "ip -s -s neigh show",
++                    ns_cmd_prefix + "ip rule list",
+                     ns_cmd_prefix + "iptables-save",
+                     ns_cmd_prefix + "netstat %s -neopa" % self.ns_wide,
+                     ns_cmd_prefix + "netstat -s",
diff -pruN 4.0-1/debian/patches/series 4.0-1ubuntu3/debian/patches/series
--- 4.0-1/debian/patches/series	2020-08-19 22:49:24.000000000 +0000
+++ 4.0-1ubuntu3/debian/patches/series	2020-10-26 14:59:33.000000000 +0000
@@ -1,2 +1,8 @@
 0001-debian-change-tmp-dir-location.patch
 0002-fix-dict-order-py38-incompatibility.patch
+0003-sosclean-fix-handling-of-filepath-with-archive-name.patch
+0004-sosclean-fix-tarball-skipping-regex.patch
+0005-ceph-collect-balancer-and-pg-autoscale-status.patch
+0006-rabbitmq-add-info-on-maybe-stuck-processes.patch
+0007-rabbitmq-add-10sec-timeout-to-call-to-maybestuck.patch
+0008-networking-include-ip-neigh-and-rule-info.patch
